REM Error list data file creation utility v1.1a for SIC v8.7a

' get sic include file
REM $INCLUDE: 'sic.inc'

' display header
COLOR 15, 0
PRINT "Makedata utility v1.1a"
COLOR 14, 0

' get error string data filename
Filename$ = ErrorList

' check filename exists
IF DIR$(Filename$) <> Nul THEN
   ' prompt to overwrite data file
   PRINT "Data file already exists."
   ' get keystroke
   DO
      PRINT "Overwrite(y/n)?";
      Char$ = Nul
      DO
         Char$ = Inkey$
         IF LEN(Char$) THEN
            EXIT DO
         END IF
      LOOP
      ' check response
      IF LCASE$(Char$) = "y" THEN
         PRINT "y"
         EXIT DO
      END IF
      IF LCASE$(Char$) = "n" THEN
         PRINT "n"
         GOTO End.Prog
      END IF
      PRINT
   LOOP
END IF

' open file
OPEN Filename$ FOR OUTPUT AS #1

' write data strings to file
DO
   READ Var$
   IF Var$ = "-eof-" THEN
      EXIT DO
   END IF
   PRINT #1, Var$
LOOP
PRINT "Data file '"+ErrorList+"' created."

End.Prog:

' end program
COLOR 7, 0
PRINT "Program end."
END

' declare all error strings
DATA "Internal Error #001: Next without For."
DATA "Error #002: Line%1: Syntax error."
DATA "Internal Error #003: Return without Gosub."
DATA "Internal Error #004: Out of Data."
DATA "Error #005: Line%1: Illegal function call."
DATA "Error #006: Line%1: Overflow."
DATA "Error #007: Line%1: Out of memory."
DATA "Internal Error #008: Label not defined."
DATA "Error #009: Line%1: Subscript out of range."
DATA "Internal Error #010: Duplicate definition."
DATA "Error #011: Line%1: Division by zero."
DATA "Internal Error #012: Illegal in direct mode."
DATA "Internal Error #013: Type mismatch."
DATA "Error #014: Line%1: Out of string space."
DATA "Error #015: Line%1: Invalid Pset statement."
DATA "Error #016: Line%1: String formula too complex."
DATA "Reserved Error #017: Cannot continue."
DATA "Internal Error #018: Function not defined."
DATA "Error #019: Line%1: No Resume."
DATA "Error #020: Line%1: Resume without error."
DATA "Error #021: Line%1: Syntax error specifying filename to open."
DATA "Error #022: Line%1: Syntax error specifying filename to close."
DATA "Error #023: Line%1: Syntax error specifying filename field."
DATA "Error #024: Line%1: Device timeout."
DATA "Error #025: Line%1: Device fault."
DATA "Internal Error #026: For without Next."
DATA "Error #027: Line%1: Out of paper."
DATA "Error #028: Line%1: Invalid LINE statement."
DATA "Internal Error #029: While without Wend."
DATA "Internal Error #030: Wend without While."
DATA "Error #031: Line%1: Syntax error writing to file."
DATA "Error #032: Line%1: Syntax error printing to file."
DATA "Internal Error #033: Duplicate label."
DATA "Error #034: Line%1: Syntax error inputing from file."
DATA "Internal Error #035: Subprogram not defined."
DATA "Error #036: Line%1: Syntax error line inputing from file."
DATA "Internal Error #037: Argument-count mismatch."
DATA "Error #038: Line%1: Array not defined."
DATA "Error #039: Line%1: Invalid CIRCLE statement."
DATA "Error #040: Line%1: Variable required."
DATA "Error #041: Line%1: Invalid Lset statement."
DATA "Error #042: Line%1: Invalid Rset statement."
DATA "Error #043: Line%1: Invalid Put statement."
DATA "Error #044: Line%1: Invalid Get statement."
DATA "Error #045: Line%1: Invalid Read statement."
DATA "Error #046: Line%1: Invalid Draw statement."
DATA "Error #047: Line%1: Invalid Play statement."
DATA "Error #048: Line%1: Invalid Paint statement."
DATA "Error #049: Line%1: Invalid Get/Put statement."
DATA "Error #050: Line%1: Field overflow."
DATA "Internal compiler error #051."
DATA "Error #052: Line%1: Bad file name or number."
DATA "Error #053: Line%1: File not found."
DATA "Error #054: Line%1: Bad file mode."
DATA "Error #055: Line%1: File already open."
DATA "Error #056: Line%1: Field statement active."
DATA "Error #057: Line%1: Device I/O error."
DATA "Error #058: Line%1: File already exists."
DATA "Error #059: Line%1: Bad record length."
DATA "Error #060: Line%1: Invalid Bsave/Bload statement."
DATA "Error #061: Line%1: Disk full."
DATA "Error #062: Line%1: Input past end of file."
DATA "Error #063: Line%1: Bad record number."
DATA "Error #064: Line%1: Bad file name."
DATA "Error #065: Line%1: Invalid Data statement."
DATA "Error #066: Line%1: Out of data."
DATA "Error #067: Line%1: Too many files."
DATA "Error #068: Line%1: Device unavailable."
DATA "Error #069: Line%1: Communication buffer overflow."
DATA "Error #070: Line%1: File permission denied."
DATA "Error #071: Line%1: Disk not ready."
DATA "Error #072: Line%1: Disk-media error."
DATA "Internal Error #073: Feature unavailable."
DATA "Error #074: Line%1: Rename across disks."
DATA "Error #075: Line%1: Path/File access error."
DATA "Error #076: Line%1: Path not found."
DATA "Error #077: Line%1: Invalid View statement."
DATA "Error #078: Line%1: Invalid Window statement."
DATA "User defined error #079: Line%1."
DATA "Internal Error #080: Feature removed."
DATA "Error #081: Line%1: Invalid name."
DATA "Reserved Error #082: Table not found."
DATA "Reserved Error #083: Index not found."
DATA "Reserved Error #084: Invalid column."
DATA "Reserved Error #085: No current record."
DATA "Reserved Error #086: Duplicate value for unique index."
DATA "Reserved Error #087: Invalid operation on null index."
DATA "Reserved Error #088: Database needs repair."
DATA "Reserved Error #089: Insufficient ISAM buffers."
DATA "User defined error #090: Line%1."
DATA "Error #091: Line%1: Unknown statement."
DATA "Error #092: Line%1: Whatis: %2."
DATA "User defined error #093: Line%1."
DATA "User defined error #094: Line%1."
DATA "User defined error #095: Line%1."
DATA "User defined error #096: Line%1."
DATA "Error #097: Line%1: Mismatched for/next."
DATA "Error #098: Line%1: Mismatched do/loop."
DATA "Error #099: Line%1: Missing line number."
DATA "Error #100: Line%1: Unmatched gosub."
DATA "Error #101: Error accessing file."
DATA "Error #102: Line%1: Mismatched select/end select."
DATA "Error #103: Line%1: Mismatched forif/nextif."
DATA "Error #104: Line%1: Mismatched loopif/endloopif."
DATA "Error #105: Line%1: Mismatched selectif/end selectif."
DATA "User defined error #106: Line%1."
DATA "User defined error #107: Line%1."
DATA "User defined error #108: Line%1."
DATA "User defined error #109: Line%1."
DATA "Error #110: Line%1: Unknown swap statement."
DATA "Error #111: Line%1: Record size overflow."
DATA "Error #112: Line%1: Error chaining to program."
DATA "Error #113: Line%1: Error naming file."
DATA "Error #114: Line%1: Error killing file."
DATA "Error #115: Line%1: Error changing directory."
DATA "Error #116: Line%1: Error making directory."
DATA "Error #117: Line%1: Error removing directory."
DATA "Error #118: Line%1: Error setting date."
DATA "Error #119: Line%1: Error setting time."
DATA "Error #120: Line%1: Error changing drive."
DATA "Error #121: Line%1: Error using OUT statement."
DATA "Error #122: Line%1: Error using WAIT statement."
DATA "Error #123: Line%1: Error using ABSOLUTE statement."
DATA "Error #124: Line%1: Error using POKE statement."
DATA "Error #125: Line%1: Error using DEFSEG statement."
DATA "Error #126: Line%1: Error specifying file handle number."
DATA "Error #127: Line%1: Error specifying hexidecimal number."
DATA "Error #128: Line%1: Error specifying octal number."
DATA "Error #129: Line%1: Error specifying binary number."
DATA "Error #130: Line%1: Error specifying decimal value."
DATA "Error #131: Line%1: Error specifying numeric value."
DATA "Error #132: Line%1: Error specifying factorial value."
DATA "Error #133: Line%1: Error specifying quoted value."
DATA "Error #134: Line%1: Bad input variable."
DATA "Error #135: Line%1: Mismatched data."
DATA "Error #136: Line%1: Too few input variables."
DATA "Error #137: Line%1: Too many input variables."
DATA "Error #138: Line%1: Missing left parenthesis."
DATA "Error #139: Line%1: Missing right parenthesis."
DATA "Error #140: Line%1: Specified double exponent."
DATA "Error #141: Line%1: Missing exponent value."
DATA "Error #142: Line%1: Bad exponent unary sign."
DATA "Error #143: Line%1: Bad exponent decimal point."
DATA "Error #144: Line%1: Bad DEF FN declaration."
DATA "Error #145: Line%1: Unknown line number."
DATA "Error #146: Line%1: Bad WIDTH statement."
DATA "Error #147: Line%1: Bad SOUND statement."
DATA "Error #148: Line%1: FN call error: %2."
DATA "Error #149: Line%1: FZ call error: %2."
DATA "Error #150: Line%1: Bad exponent unary sign."
DATA "Error #151: Line%1: Bad exponent decimal point."
DATA "User defined error #152: Line%1."
DATA "User defined error #153: Line%1."
DATA "Error #154: Line%1: Bad SHELL call."
DATA "Error #155: Line%1: Restricted command."
DATA "Error #156: Line%1: Maximum nested gosub."
DATA "Error #157: Line%1: Square root of a negative value."
DATA "Error #158: Line%1: Unknown INT86 function."
DATA "Error #159: Line%1: Feature not available."
DATA "Error #160: Line%1: Unknown metacommand."
DATA "Error #161: Line%1: Illegal printer function call."
DATA "Error #162: Line%1: Illegal MID$ function call."
DATA "Error #163: Line%1: Illegal LEFT$ function call."
DATA "Error #164: Line%1: Illegal RIGHT$ function call."
DATA "Error #165: Line%1: Illegal ENVIRON$ function call."
DATA "Error #166: Line%1: Drive not available."
DATA "User defined error #167: Line%1."
DATA "User defined error #168: Line%1."
DATA "User defined error #169: Line%1."
DATA "User defined error #170: Line%1."
DATA "User defined error #171: Line%1."
DATA "User defined error #172: Line%1."
DATA "User defined error #173: Line%1."
DATA "User defined error #174: Line%1."
DATA "User defined error #175: Line%1."
DATA "User defined error #176: Line%1."
DATA "User defined error #177: Line%1."
DATA "User defined error #178: Line%1."
DATA "User defined error #179: Line%1."
DATA "User defined error #180: Line%1."
DATA "User defined error #181: Line%1."
DATA "User defined error #182: Line%1."
DATA "User defined error #183: Line%1."
DATA "User defined error #184: Line%1."
DATA "User defined error #185: Line%1."
DATA "User defined error #186: Line%1."
DATA "User defined error #187: Line%1."
DATA "User defined error #188: Line%1."
DATA "User defined error #189: Line%1."
DATA "User defined error #190: Line%1."
DATA "User defined error #191: Line%1."
DATA "User defined error #192: Line%1."
DATA "User defined error #193: Line%1."
DATA "User defined error #194: Line%1."
DATA "User defined error #195: Line%1."
DATA "User defined error #196: Line%1."
DATA "User defined error #197: Line%1."
DATA "User defined error #198: Line%1."
DATA "User defined error #199: Line%1."
DATA "User defined error #200: Line%1."
DATA "User defined error #201: Line%1."
DATA "User defined error #202: Line%1."
DATA "User defined error #203: Line%1."
DATA "User defined error #204: Line%1."
DATA "User defined error #205: Line%1."
DATA "User defined error #206: Line%1."
DATA "User defined error #207: Line%1."
DATA "User defined error #208: Line%1."
DATA "User defined error #209: Line%1."
DATA "User defined error #210: Line%1."
DATA "User defined error #211: Line%1."
DATA "User defined error #212: Line%1."
DATA "User defined error #213: Line%1."
DATA "User defined error #214: Line%1."
DATA "User defined error #215: Line%1."
DATA "User defined error #216: Line%1."
DATA "User defined error #217: Line%1."
DATA "User defined error #218: Line%1."
DATA "User defined error #219: Line%1."
DATA "User defined error #220: Line%1."
DATA "User defined error #221: Line%1."
DATA "User defined error #222: Line%1."
DATA "User defined error #223: Line%1."
DATA "User defined error #224: Line%1."
DATA "User defined error #225: Line%1."
DATA "User defined error #226: Line%1."
DATA "User defined error #227: Line%1."
DATA "User defined error #228: Line%1."
DATA "User defined error #229: Line%1."
DATA "User defined error #230: Line%1."
DATA "User defined error #231: Line%1."
DATA "User defined error #232: Line%1."
DATA "User defined error #233: Line%1."
DATA "User defined error #234: Line%1."
DATA "User defined error #235: Line%1."
DATA "User defined error #236: Line%1."
DATA "User defined error #237: Line%1."
DATA "User defined error #238: Line%1."
DATA "User defined error #239: Line%1."
DATA "User defined error #240: Line%1."
DATA "User defined error #241: Line%1."
DATA "User defined error #242: Line%1."
DATA "User defined error #243: Line%1."
DATA "User defined error #244: Line%1."
DATA "User defined error #245: Line%1."
DATA "User defined error #246: Line%1."
DATA "User defined error #247: Line%1."
DATA "User defined error #248: Line%1."
DATA "User defined error #249: Line%1."
DATA "User defined error #250: Line%1."
DATA "User defined error #251: Line%1."
DATA "User defined error #252: Line%1."
DATA "User defined error #253: Line%1."
DATA "User defined error #254: Line%1."
DATA "User defined error #255: Line%1."
DATA "-eof-"
